#
# spec file for package git (Version 1.5.2.4)
#
# Copyright (c) 2008 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# usedforbuild    Mesa aaa_base acl asciidoc attr audit-libs autoconf automake bash binutils brp-check-internal bzip2 cairo coreutils cpio cpp cpp42 cracklib cups-libs curl-ca-bundle cvs diffutils docbook-xsl-stylesheets docbook_4 file filesystem fillup findutils fontconfig freetype2 gawk gcc gcc42 gd gdbm gettext gettext-devel ghostscript-fonts-std ghostscript-library ghostscript-x11 glib2 glibc glibc-devel glibc-locale glitz grep groff gzip info insserv less libacl libattr libbz2-1 libbz2-devel libcurl-devel libcurl4 libdb-4_5 libdrm libexpat1 libgcc42 libgcrypt libgimpprint libgomp42 libgpg-error libidn libidn-devel libjpeg libltdl-3 libmudflap42 libopenssl-devel libopenssl0_9_8 libpng libreadline5 libstdc++42 libtiff3 libtool libuuid1 libvolume_id libxcrypt libxml2 libxslt libzio linux-kernel-headers m4 make man mktemp ncurses net-tools netcfg openssl-certs pam pam-modules passivetex patch pcre perl perl-Tk perl-base permissions poppler popt post-build-checks python rpm sed sgml-skel sqlite sysvinit t1lib tar texinfo texlive texlive-bin texlive-bin-latex texlive-latex timezone util-linux xaw3d xmltex xmlto xorg-x11-libICE xorg-x11-libSM xorg-x11-libX11 xorg-x11-libXau xorg-x11-libXext xorg-x11-libXfixes xorg-x11-libXmu xorg-x11-libXp xorg-x11-libXpm xorg-x11-libXprintUtil xorg-x11-libXrender xorg-x11-libXt xorg-x11-libXv xorg-x11-libfontenc xorg-x11-libs xorg-x11-libxcb xorg-x11-libxkbfile zlib zlib-devel


Name:           git
BuildRequires:  asciidoc curl-devel sgml-skel xmlto
Version:        1.5.2.4
Release:        24.4
Summary:        Fast, scalable, distributed revision control system
License:        GPL v2 or later
Group:          Development/Tools/Version Control
Url:            http://git.or.cz
Source0:        git-%{version}.tar.bz2
Patch1:         nov415345-1.diff
Patch2:         nov415345-2.diff
Patch3:         nov415345-3.diff
Patch4:         hack-strbuf-for-old-git.diff
Patch5:         nov456444.diff
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Requires:       git-core, git-svn, git-cvs, git-arch, git-email, gitk

%description
Git is a fast, scalable, distributed revision control system with an
unusually rich command set that provides both high-level operations and
full access to internals.

This package itself only provides the README of git but with the
packages it requires, it brings you a complete Git environment
including GTK and email interfaces and tools for importing source code
repositories from other revision control systems such as subversion,
CVS, and GNU arch.



Authors:
--------
    Linus Torvalds <torvalds@osdl.org>

%debug_package
%package core
License:        GPL v2 or later
Summary:        Core git tools
Group:          Development/Tools/Version Control
Requires:       rsync, curl, less, openssh

%description core
Git is a fast, scalable, distributed revision control system with an
unusually rich command set that provides both high-level operations and
full access to internals.

These are the core tools with minimal dependencies.



Authors:
--------
    Linus Torvalds <torvalds@osdl.org>
    Junio C Hamano <junkio@cox.net>

%package svn
License:        GPL v2 or later
Summary:        Git tools for importing Subversion repositories
Group:          Development/Tools/Version Control
Requires:       git-core = %{version}-%{release}, subversion
Requires:       subversion-perl

%description svn
Tools for importing Subversion repositories to the Git version control
system.



Authors:
--------
    Linus Torvalds <torvalds@osdl.org>
    Junio C Hamano <junkio@cox.net>

%package cvs
License:        GPL v2 or later
Summary:        Git tools for importing CVS repositories
Group:          Development/Tools/Version Control
Requires:       git-core = %{version}-%{release}, cvs, cvsps

%description cvs
Tools for importing CVS repositories to the Git version control system.



Authors:
--------
    Linus Torvalds <torvalds@osdl.org>
    Junio C Hamano <junkio@cox.net>

%package arch
License:        GPL v2 or later
Summary:        git-arch - Git tools for importing Arch repositories
Group:          Development/Tools/Version Control
Requires:       git-core = %{version}-%{release}, tla

%description arch
Tools for importing GNU Arch repositories to the GIT version control
system.



Authors:
--------
    Linus Torvalds <torvalds@osdl.org>
    Junio C Hamano <junkio@cox.net>

%package email
License:        GPL v2 or later
Summary:        Git tools for sending email
Group:          Development/Tools/Version Control
Requires:       git-core = %{version}-%{release} 

%description email
Email interface for the GIT version control system.



Authors:
--------
    Linus Torvalds <torvalds@osdl.org>
    Junio C Hamano <junkio@cox.net>

%package -n gitk
License:        GPL v2 or later
Summary:        Git revision tree visualiser
Group:          Development/Tools/Version Control
Requires:       git-core = %{version}-%{release}, tk >= 8.4

%description -n gitk
Grapical tool for visualization of revision trees of projects
maintained in the Git version control system. It name gitk indicates
that it's written using the Tk Widget set.

A simple Tk based graphical interface for common Git operations is
found in the package git-gui.



Authors:
--------
    Linus Torvalds <torvalds@osdl.org>
    Junio C Hamano <junkio@cox.net>

%prep
%setup
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

%build
make %{_smp_mflags} CFLAGS="$RPM_OPT_FLAGS" \
       GITWEB_CONFIG="/etc/gitweb.conf" \
       GITWEB_PROJECTROOT="/srv/git" \
       WITH_OWN_SUBPROCESS_PY=YesPlease NO_EXPAT=1 \
       prefix=%{_prefix} mandir=%{_mandir} \
       all %{!?without_docs: doc} %{?jobs:-j %jobs}

%install
rm -rf $RPM_BUILD_ROOT
make %{_smp_mflags} CFLAGS="$RPM_OPT_FLAGS" DESTDIR=$RPM_BUILD_ROOT WITH_OWN_SUBPROCESS_PY=YesPlease NO_EXPAT=1 \
     prefix=%{_prefix} mandir=%{_mandir} \
     install %{!?_without_docs: install-doc}
install -d ${RPM_BUILD_ROOT}/srv/git
install -d ${RPM_BUILD_ROOT}/srv/www/cgi-bin
cp gitweb/gitweb.cgi $RPM_BUILD_ROOT/srv/www/cgi-bin/gitweb.cgi
(find $RPM_BUILD_ROOT%{_bindir} -type f | grep -vE "archimport|svn|cvs|email|gitk" | sed -e s@^$RPM_BUILD_ROOT@@)               > bin-man-doc-files
%if %{!?_without_docs:1}0
(find $RPM_BUILD_ROOT%{_mandir} $RPM_BUILD_ROOT/Documentation -type f | grep -vE "archimport|svn|git-cvs|email|gitk" | sed -e s@^$RPM_BUILD_ROOT@@ -e 's/$/*/' ) >> bin-man-doc-files
%endif
( pushd perl
  perl Makefile.PL
  make -f perl.mak DESTDIR=${RPM_BUILD_ROOT}  install_vendor
)
rm -rf ${RPM_BUILD_ROOT}/usr/lib/perl5/site_perl
%perl_process_packlist
find $RPM_BUILD_ROOT/%_mandir -type f -print0 | xargs -0 chmod 644

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc README

%files svn
%defattr(-,root,root)
%{_bindir}/*svn*
%doc Documentation/*svn*.txt
%{!?_without_docs: %{_mandir}/man1/*svn*.1*}
%{!?_without_docs: %doc Documentation/*svn*.html }

%files cvs
%defattr(-,root,root)
%doc Documentation/*git-cvs*.txt
%{_bindir}/*cvs*
%{!?_without_docs: %{_mandir}/man1/*cvs*.1*}
%{!?_without_docs: %doc Documentation/*git-cvs*.html }

%files arch
%defattr(-,root,root)
%doc Documentation/git-archimport.txt
%{_bindir}/git-archimport
%{!?_without_docs: %{_mandir}/man1/git-archimport.1*}
%{!?_without_docs: %doc Documentation/git-archimport.html }

%files email
%defattr(-,root,root)
%doc Documentation/*email*.txt
%{_bindir}/*email*
%{!?_without_docs: %{_mandir}/man1/*email*.1*}
%{!?_without_docs: %doc Documentation/*email*.html }

%files -n gitk
%defattr(-,root,root)
%doc Documentation/*gitk*.txt
%{_bindir}/*gitk*
%{!?_without_docs: %{_mandir}/man1/*gitk*.1*}
%{!?_without_docs: %doc Documentation/*gitk*.html }

%files core -f bin-man-doc-files
%defattr(-,root,root)
%{_datadir}/git-core/
/srv/git/
/srv/www/cgi-bin/gitweb.cgi
%doc README COPYING Documentation/*.txt
%{!?_without_docs: %doc Documentation/*.html }
/var/adm/perl-modules/%{name}
%{perl_vendorlib}/Error.pm
%{perl_vendorlib}/Git.pm
%{perl_vendorarch}/auto/Git/
/usr/share/git-gui

%changelog
* Thu Dec 11 2008 - pbaudis@suse.cz
- Fix insufficient quoting of shell characters that allowed remote
  attackers to execute arbitrary commands via gitweb [bnc#456444]
* Fri Aug 08 2008 - matz@suse.de
- Fix buffer overflows in several tools with repositories containing
  pathnames longer than PATH_MAX.  [bnc #415345]
* Mon Aug 06 2007 - dmueller@suse.de
- update to 1.5.2.4:
  * "git checkout" failed to switch back and forth between
  branches, one of which has "frotz -> xyzzy" symlink and
  file "xyzzy/filfre", while the other one has a file
  "frotz/filfre".
  * "git prune" used to segfault upon seeing a commit that is
  referred to by a tree object (aka "subproject").
  * "git diff --name-status --no-index" mishandled an added file.
  * "git apply --reverse --whitespace=warn" still complained
  about whitespaces that a forward application would have
  introduced.
* Thu Jul 05 2007 - dmueller@suse.de
- Update to 1.5.2.3:
  * fix many segfaults with the SVN gateway
  * various bugfixes
* Thu May 17 2007 - dmueller@suse.de
- Update to 1.5.1.4:
  * GIT <-> SVN gateway
  * New porcelain, much improved index handling
  * git-config
  * Bare repositories refuse commands that need a working tree
  * packed ref support
  * 3-way merges can be done without rcs
  * python dependency dropped
* Sat Nov 18 2006 - pbaudis@suse.cz
- Fix build failure from previous change (trivial omission)
* Fri Nov 17 2006 - pbaudis@suse.cz
- Fix git-arch package containing git-archive and git-upload-archive
  [#222074]
* Fri Nov 17 2006 - pbaudis@suse.cz
- Upgrade to git-1.4.3.4 - only few bugfixes, most importantly
  git-apply wouldn't apply creation/deletion patches
* Tue Nov 07 2006 - ro@suse.de
- fix permissions for manpages
* Sat Oct 28 2006 - meissner@suse.de
- use RPM_OPT_FLAGS also in %%install make
* Thu Oct 26 2006 - pbaudis@suse.cz
- Upgrade to git-1.4.3.3 - bugfixes release
* Thu Oct 19 2006 - pbaudis@suse.cz
- Update to git-1.4.3 - UI improvements, speedups, random new
  features (e.g. git-daemon name-based virtual hosting support),
  basic Git.pm
- Fixes build failures due to asciidoc incompatibilities
* Tue Jul 25 2006 - pbaudis@suse.cz
- Update to git-1.4.1.1 - includes gitweb, many bugfixes, some
  commands are converted from shell to C, aliasing support,
  documentation improvements and so on.
- Junio's patch got applied upstream.
- Pre-create /srv/git for bare Git repositories hosting.
- Install gitweb to /srv/www/cgi-bin pre-configured to look
  for packages at /srv/git.
* Mon May 15 2006 - pbaudis@suse.cz
- Update to git-core-1.3.1 - git-cvsserver pserver interface,
  .git/refs/remotes branches support, blame/annotate tools,
  builtin diff, faster and better rename detection and number
  of other stuff.
- Add Junio's patch for saner handling of symlink refs. This is
  an important bugfix since without this, it is impossible to
  bisect behind kernel linux-v2.6.15-g117a93d.
- Olaf Hering's cutnpaste patch got applied upstream.
* Mon Mar 13 2006 - ro@suse.de
- change requires from "openssh-clients" to "openssh"
  (former does not exist)
* Fri Mar 10 2006 - pbaudis@suse.cz
- Add Olaf Hering's patch for easier cut'n'pasting.
* Tue Mar 07 2006 - pbaudis@suse.cz
- Update to git-core 1.2.4.
- This is a security fix: there was a buffer overflow when checking
  out a tree with an insanely long symlink. (No Bugzilla id.)
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Tue Jan 17 2006 - pbaudis@suse.cz
- Fix the specfile build (no expat and asciidoc, xmlto problems)
* Mon Jan 16 2006 - pbaudis@suse.cz
- Update to git-core 1.1.3.
- Modify the specfile so that it looks more like the stock one.
- Split bits to subpackages
* Sun Dec 04 2005 - schwab@suse.de
- Fix embedded paths.
* Wed Oct 05 2005 - schwab@suse.de
- Don't build documentation in parallel.
* Mon Sep 19 2005 - schwab@suse.de
- Update to git-core 0.99.7.
- Install manpages.
* Fri Aug 05 2005 - kasievers@suse.de
- New version 0.99.3git20050905
  rename git to git-core, to match the upstream package name
* Sun Jul 03 2005 - kasievers@suse.de
- New version 0.7git20050703
* Thu Jun 30 2005 - kasievers@suse.de
- New version 20050630
* Fri Jun 24 2005 - kasievers@suse.de
- New version 20050624
* Sun Jun 12 2005 - kay.sievers@suse.de
- New version 20050612
* Thu Jun 02 2005 - kay.sievers@suse.de
- Split git/Cogito into separate packages
- Update git to version 20050602
* Fri May 20 2005 - schwab@suse.de
- Use RPM_OPT_FLAGS.
- Specfile cleanup.
* Fri May 20 2005 - mmj@suse.de
- %%_libdir -> FHS libexec
* Fri May 20 2005 - skh@suse.de
- initial package
